diff --git a/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverter19132To19133.java b/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverter19132To19133.java
index 0674d27fe..d2c56cabd 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverter19132To19133.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverter19132To19133.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.world.save.conversion;
 
 import com.mojang.logging.LogUtils;
-import com.mojang.nbt.CompoundTag;
+import com.mojang.nbt.tags.CompoundTag;
 import com.mojang.nbt.NbtIo;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.ProgressListener;
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverter19133To19134.java b/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverter19133To19134.java
index 4f278edf6..89ca0dda9 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverter19133To19134.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverter19133To19134.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.world.save.conversion;
 
 import com.mojang.logging.LogUtils;
-import com.mojang.nbt.CompoundTag;
+import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.data.legacy.LegacyWorldTypes;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.ProgressListener;
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverterLegacyTo19132.java b/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverterLegacyTo19132.java
index b3df2469a..075b31c56 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverterLegacyTo19132.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverterLegacyTo19132.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.world.save.conversion;
 
 import com.mojang.logging.LogUtils;
-import com.mojang.nbt.CompoundTag;
+import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.data.legacy.LegacyWorldTypes;
 import net.minecraft.core.world.ProgressListener;
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverterMCRegionBase.java b/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverterMCRegionBase.java
index 4aac46f4d..37f5bae97 100644
--- a/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverterMCRegionBase.java
+++ b/game/core/src/main/java/net/minecraft/core/world/save/conversion/SaveConverterMCRegionBase.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.world.save.conversion;
 
-import com.mojang.nbt.CompoundTag;
+import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.ProgressListener;
 import net.minecraft.core.world.save.ISaveConverter;
diff --git a/game/core/src/main/java/net/minecraft/core/world/saveddata/SavedData.java b/game/core/src/main/java/net/minecraft/core/world/saveddata/SavedData.java
index 827fe0528..18baf642e 100644
--- a/game/core/src/main/java/net/minecraft/core/world/saveddata/SavedData.java
+++ b/game/core/src/main/java/net/minecraft/core/world/saveddata/SavedData.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.world.saveddata;
 
-import com.mojang.nbt.CompoundTag;
+import com.mojang.nbt.tags.CompoundTag;
 
 public abstract class SavedData
 {
diff --git a/game/core/src/main/java/net/minecraft/core/world/saveddata/SavedDataStorage.java b/game/core/src/main/java/net/minecraft/core/world/saveddata/SavedDataStorage.java
index d1558df66..0116f218e 100644
--- a/game/core/src/main/java/net/minecraft/core/world/saveddata/SavedDataStorage.java
+++ b/game/core/src/main/java/net/minecraft/core/world/saveddata/SavedDataStorage.java
@@ -1,9 +1,9 @@
 package net.minecraft.core.world.saveddata;
 
 import com.mojang.logging.LogUtils;
-import com.mojang.nbt.Tag;
-import com.mojang.nbt.CompoundTag;
-import com.mojang.nbt.ShortTag;
+import com.mojang.nbt.tags.Tag;
+import com.mojang.nbt.tags.CompoundTag;
+import com.mojang.nbt.tags.ShortTag;
 import com.mojang.nbt.NbtIo;
 import net.minecraft.core.world.save.LevelStorage;
 import org.slf4j.Logger;
diff --git a/game/core/src/main/java/net/minecraft/core/world/saveddata/maps/ItemMapSavedData.java b/game/core/src/main/java/net/minecraft/core/world/saveddata/maps/ItemMapSavedData.java
index a32faab15..92db2c965 100644
--- a/game/core/src/main/java/net/minecraft/core/world/saveddata/maps/ItemMapSavedData.java
+++ b/game/core/src/main/java/net/minecraft/core/world/saveddata/maps/ItemMapSavedData.java
@@ -4,8 +4,8 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntityFlag;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
-import com.mojang.nbt.CompoundTag;
-import com.mojang.nbt.ListTag;
+import com.mojang.nbt.tags.CompoundTag;
+import com.mojang.nbt.tags.ListTag;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.saveddata.SavedData;
diff --git a/game/core/src/main/java/net/minecraft/core/world/saveddata/maps/MapWaypoint.java b/game/core/src/main/java/net/minecraft/core/world/saveddata/maps/MapWaypoint.java
index e769dd621..db053e1c0 100644
--- a/game/core/src/main/java/net/minecraft/core/world/saveddata/maps/MapWaypoint.java
+++ b/game/core/src/main/java/net/minecraft/core/world/saveddata/maps/MapWaypoint.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.world.saveddata.maps;
 
-import com.mojang.nbt.CompoundTag;
+import com.mojang.nbt.tags.CompoundTag;
 
 import java.io.DataInputStream;
 import java.io.DataOutputStream;
diff --git a/game/server/build.gradle.kts b/game/server/build.gradle.kts
index c16e586bb..2d965b857 100644
--- a/game/server/build.gradle.kts
+++ b/game/server/build.gradle.kts
@@ -25,6 +25,8 @@ dependencies {
     implementation(libs.gson)?.let { include(it) }
     implementation(libs.brigadier)?.let { include(it) }
     implementation(libs.bundles.log4j)?.let { include(it) }
+    implementation(project(":util:nbt"))?.let { include(it) }
+    implementation(project(":util:logging"))?.let { include(it) }
     // </core dependencies>
 }
 
diff --git a/game/server/src/main/java/net/minecraft/server/MinecraftServer.java b/game/server/src/main/java/net/minecraft/server/MinecraftServer.java
index f2359f95d..0a37607a5 100644
--- a/game/server/src/main/java/net/minecraft/server/MinecraftServer.java
+++ b/game/server/src/main/java/net/minecraft/server/MinecraftServer.java
@@ -2,7 +2,7 @@ package net.minecraft.server;
 
 import com.mojang.brigadier.exceptions.CommandSyntaxException;
 import com.mojang.logging.LogUtils;
-import com.mojang.nbt.CompoundTag;
+import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.Global;
 import net.minecraft.core.MinecraftAccessor;
 import net.minecraft.core.achievement.stat.StatList;
diff --git a/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java b/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
index aefb04f7f..cac8ecec3 100644
--- a/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
+++ b/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
@@ -13,7 +13,7 @@ import net.minecraft.core.item.Item;
 import net.minecraft.core.item.IComplexItem;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.lang.I18n;
-import com.mojang.nbt.CompoundTag;
+import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.player.inventory.menu.*;
diff --git a/game/server/src/main/java/net/minecraft/server/player/PlayerManager.java b/game/server/src/main/java/net/minecraft/server/player/PlayerManager.java
index 741d6918a..d57432252 100644
--- a/game/server/src/main/java/net/minecraft/server/player/PlayerManager.java
+++ b/game/server/src/main/java/net/minecraft/server/player/PlayerManager.java
@@ -4,7 +4,6 @@ import java.util.ArrayList;
 import java.util.List;
 
 import com.mojang.logging.LogUtils;
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.net.packet.*;
diff --git a/settings.gradle.kts b/settings.gradle.kts
index 54db8e0a2..e0ae3ae5f 100644
--- a/settings.gradle.kts
+++ b/settings.gradle.kts
@@ -6,3 +6,7 @@ include("util:stellar")
 include("util:datagen")
 include("util:seed-viewer")
 findProject(":util:seed-viewer")?.name = "seed-viewer"
+include("util:nbt")
+findProject(":util:nbt")?.name = "nbt"
+include("util:logging")
+findProject(":util:logging")?.name = "logging"
diff --git a/util/logging/.gitignore b/util/logging/.gitignore
new file mode 100644
index 000000000..c795b054e
--- /dev/null
+++ b/util/logging/.gitignore
@@ -0,0 +1 @@
+build
\ No newline at end of file
diff --git a/util/logging/build.gradle.kts b/util/logging/build.gradle.kts
new file mode 100644
index 000000000..ee3683f2a
--- /dev/null
+++ b/util/logging/build.gradle.kts
@@ -0,0 +1,31 @@
+plugins {
+    id("java")
+}
+
+group = "com.mojang"
+version = "1.0.0"
+
+repositories {
+    mavenCentral()
+}
+
+dependencies {
+    testImplementation(platform("org.junit:junit-bom:5.10.0"))
+    testImplementation("org.junit.jupiter:junit-jupiter")
+
+    implementation(libs.jetbrains.annotations)
+    implementation(libs.bundles.log4j)
+}
+
+java {
+    sourceCompatibility = JavaVersion.VERSION_1_8
+    targetCompatibility = JavaVersion.VERSION_1_8
+}
+
+tasks.withType(Jar::class.java) {
+    dependsOn(tasks.test)
+}
+
+tasks.test {
+    useJUnitPlatform()
+}
\ No newline at end of file
diff --git a/util/nbt/.gitignore b/util/nbt/.gitignore
new file mode 100644
index 000000000..6ca7a5037
--- /dev/null
+++ b/util/nbt/.gitignore
@@ -0,0 +1,2 @@
+build
+testWork
\ No newline at end of file
diff --git a/util/nbt/build.gradle.kts b/util/nbt/build.gradle.kts
new file mode 100644
index 000000000..bf526f429
--- /dev/null
+++ b/util/nbt/build.gradle.kts
@@ -0,0 +1,34 @@
+plugins {
+    id("java")
+}
+
+group = "com.mojang"
+version = "1.1.0"
+
+repositories {
+    mavenCentral()
+}
+
+dependencies {
+    testImplementation(platform("org.junit:junit-bom:5.10.0"))
+    testImplementation("org.junit.jupiter:junit-jupiter")
+
+    implementation(libs.jetbrains.annotations)
+}
+
+java {
+    sourceCompatibility = JavaVersion.VERSION_1_8
+    targetCompatibility = JavaVersion.VERSION_1_8
+}
+
+tasks.withType(Jar::class.java) {
+    dependsOn(tasks.test)
+}
+
+tasks.withType(JavaExec::class.java) {
+    dependsOn(tasks.test)
+}
+
+tasks.test {
+    useJUnitPlatform()
+}
\ No newline at end of file
diff --git a/game/core/src/main/java/com/mojang/nbt/NbtIo.java b/util/nbt/src/main/java/com/mojang/nbt/NbtIo.java
similarity index 61%
rename from game/core/src/main/java/com/mojang/nbt/NbtIo.java
rename to util/nbt/src/main/java/com/mojang/nbt/NbtIo.java
index c062eb1c1..c4b20110e 100644
--- a/game/core/src/main/java/com/mojang/nbt/NbtIo.java
+++ b/util/nbt/src/main/java/com/mojang/nbt/NbtIo.java
@@ -1,11 +1,16 @@
 package com.mojang.nbt;
 
+import com.mojang.nbt.tags.CompoundTag;
+import com.mojang.nbt.tags.Tag;
+import org.jetbrains.annotations.NotNull;
+
 import java.io.*;
 import java.util.zip.GZIPInputStream;
 import java.util.zip.GZIPOutputStream;
 
 public class NbtIo
 {
+    @SuppressWarnings("unused")
     public static CompoundTag readCompressed(InputStream inputStream)
         throws IOException
     {
@@ -15,7 +20,8 @@ public class NbtIo
         }
     }
 
-    public static void writeCompressed(CompoundTag tag, OutputStream outputStream)
+    @SuppressWarnings("unused")
+    public static void writeCompressed(@NotNull CompoundTag tag, OutputStream outputStream)
         throws IOException
     {
         try (DataOutputStream dataoutputstream = new DataOutputStream(new GZIPOutputStream(outputStream)))
@@ -24,21 +30,19 @@ public class NbtIo
         }
     }
 
-    public static CompoundTag read(DataInput dataInput)
+    @SuppressWarnings("unused")
+    public static @NotNull CompoundTag read(DataInput dataInput)
         throws IOException
     {
         Tag<?> tag = Tag.readNamedTag(dataInput);
-        if (tag instanceof CompoundTag)
-        {
-            return (CompoundTag) tag;
-        }
-        else
-        {
+        if (!(tag instanceof CompoundTag)) {
             throw new IOException("Root tag must be a named compound tag!");
         }
+        return (CompoundTag) tag;
     }
 
-    public static void write(CompoundTag tag, DataOutput dataOutput)
+    @SuppressWarnings("unused")
+    public static void write(@NotNull CompoundTag tag, DataOutput dataOutput)
         throws IOException
     {
         Tag.writeNamedTag(tag, dataOutput);
diff --git a/util/nbt/src/main/java/com/mojang/nbt/UnknownTagException.java b/util/nbt/src/main/java/com/mojang/nbt/UnknownTagException.java
new file mode 100644
index 000000000..f28337c04
--- /dev/null
+++ b/util/nbt/src/main/java/com/mojang/nbt/UnknownTagException.java
@@ -0,0 +1,13 @@
+package com.mojang.nbt;
+
+import java.io.IOException;
+
+public class UnknownTagException extends IOException {
+    public UnknownTagException() {
+        super();
+    }
+
+    public UnknownTagException(String message) {
+        super(message);
+    }
+}
diff --git a/game/core/src/main/java/com/mojang/nbt/ByteArrayTag.java b/util/nbt/src/main/java/com/mojang/nbt/tags/ByteArrayTag.java
similarity index 62%
rename from game/core/src/main/java/com/mojang/nbt/ByteArrayTag.java
rename to util/nbt/src/main/java/com/mojang/nbt/tags/ByteArrayTag.java
index 1e2bf7539..b399301c5 100644
--- a/game/core/src/main/java/com/mojang/nbt/ByteArrayTag.java
+++ b/util/nbt/src/main/java/com/mojang/nbt/tags/ByteArrayTag.java
@@ -1,13 +1,16 @@
-package com.mojang.nbt;
+package com.mojang.nbt.tags;
+
+import org.jetbrains.annotations.NotNull;
 
 import java.io.*;
+import java.util.Arrays;
 
-public class ByteArrayTag extends Tag<byte[]>
+public class ByteArrayTag extends Tag<byte @NotNull []>
 {
 
     public ByteArrayTag()
     {
-        setValue(new byte[0]);
+        this(new byte[0]);
     }
 
     public ByteArrayTag(byte[] array)
@@ -16,7 +19,7 @@ public class ByteArrayTag extends Tag<byte[]>
     }
 
     @Override
-    void write(DataOutput dos)
+    void write(@NotNull DataOutput dos)
         throws IOException
     {
         dos.writeInt(getValue().length);
@@ -24,7 +27,7 @@ public class ByteArrayTag extends Tag<byte[]>
     }
 
     @Override
-    void read(DataInput dis)
+    void read(@NotNull DataInput dis)
         throws IOException
     {
         int length = dis.readInt();
@@ -35,7 +38,7 @@ public class ByteArrayTag extends Tag<byte[]>
     @Override
     public byte getId()
     {
-        return 7;
+        return TAG_BYTE_ARRAY;
     }
 
     @Override
@@ -57,4 +60,13 @@ public class ByteArrayTag extends Tag<byte[]>
             return sb.toString();
         }
     }
+
+    @Override
+    public boolean equals(Object obj) {
+        if(!(obj instanceof ByteArrayTag)) return false;
+        ByteArrayTag otherTag = (ByteArrayTag) obj;
+        byte[] thisData = getValue();
+        byte[] otherData = otherTag.getValue();
+        return Arrays.equals(thisData, otherData);
+    }
 }
diff --git a/game/core/src/main/java/com/mojang/nbt/ByteTag.java b/util/nbt/src/main/java/com/mojang/nbt/tags/ByteTag.java
similarity index 65%
rename from game/core/src/main/java/com/mojang/nbt/ByteTag.java
rename to util/nbt/src/main/java/com/mojang/nbt/tags/ByteTag.java
index 02322b783..1e7c306af 100644
--- a/game/core/src/main/java/com/mojang/nbt/ByteTag.java
+++ b/util/nbt/src/main/java/com/mojang/nbt/tags/ByteTag.java
@@ -1,12 +1,15 @@
-package com.mojang.nbt;
+package com.mojang.nbt.tags;
+
+import org.jetbrains.annotations.NotNull;
 
 import java.io.*;
 
-public class ByteTag extends Tag<Byte>
+public class ByteTag extends Tag<@NotNull Byte>
 {
 
     public ByteTag()
     {
+        this((byte) 0);
     }
 
     public ByteTag(byte value)
@@ -15,14 +18,14 @@ public class ByteTag extends Tag<Byte>
     }
 
     @Override
-    void write(DataOutput dos)
+    void write(@NotNull DataOutput dos)
         throws IOException
     {
         dos.writeByte(getValue());
     }
 
     @Override
-    void read(DataInput dis)
+    void read(@NotNull DataInput dis)
         throws IOException
     {
         setValue(dis.readByte());
@@ -31,7 +34,7 @@ public class ByteTag extends Tag<Byte>
     @Override
     public byte getId()
     {
-        return 1;
+        return TAG_BYTE;
     }
 
     @Override
diff --git a/game/core/src/main/java/com/mojang/nbt/CompoundTag.java b/util/nbt/src/main/java/com/mojang/nbt/tags/CompoundTag.java
similarity index 83%
rename from game/core/src/main/java/com/mojang/nbt/CompoundTag.java
rename to util/nbt/src/main/java/com/mojang/nbt/tags/CompoundTag.java
index b7d946bd5..8a6d7938e 100644
--- a/game/core/src/main/java/com/mojang/nbt/CompoundTag.java
+++ b/util/nbt/src/main/java/com/mojang/nbt/tags/CompoundTag.java
@@ -1,9 +1,11 @@
-package com.mojang.nbt;
+package com.mojang.nbt.tags;
+
+import org.jetbrains.annotations.NotNull;
 
 import java.io.*;
 import java.util.*;
 
-public class CompoundTag extends Tag<Map<String, Tag<?>>>
+public class CompoundTag extends Tag<@NotNull Map<String, Tag<?>>>
 {
     public CompoundTag()
     {
@@ -26,12 +28,12 @@ public class CompoundTag extends Tag<Map<String, Tag<?>>>
     }
 
     @Override
-    public void write(DataOutput dos)
+    public void write(@NotNull DataOutput dos)
         throws IOException
     {
         for (Tag<?> tag : getValue().values())
         {
-            Tag.writeNamedTag(tag, dos);
+            writeNamedTag(tag, dos);
         }
 
         dos.writeByte(0);
@@ -39,13 +41,13 @@ public class CompoundTag extends Tag<Map<String, Tag<?>>>
 
 
     @Override
-    public void read(DataInput dis)
+    public void read(@NotNull DataInput dis)
         throws IOException
     {
         getValue().clear();
 
         Tag<?> tag;
-        while ((tag = Tag.readNamedTag(dis)).getId() != 0)
+        while ((tag = readNamedTag(dis)).getId() != 0)
         {
             getValue().put(tag.getTagName(), tag);
         }
@@ -64,7 +66,7 @@ public class CompoundTag extends Tag<Map<String, Tag<?>>>
     @Override
     public byte getId()
     {
-        return 10;
+        return TAG_COMPOUND;
     }
 
     public Tag<?> getTagOrDefault(final String key, Tag<?> defaultTag)
@@ -307,6 +309,27 @@ public class CompoundTag extends Tag<Map<String, Tag<?>>>
         put(key, new DoubleArrayTag(array));
     }
 
+    public long[] getLongArray(String key)
+    {
+        return getLongArrayOrDefault(key, new long[0]);
+    }
+
+    public long[] getLongArrayOrDefault(String key, long[] defaultArray)
+    {
+        Tag<?> tag = getTagOrDefault(key, null);
+
+        if (!(tag instanceof LongArrayTag))
+        {
+            return defaultArray;
+        }
+        else return ((LongArrayTag)tag).getValue();
+    }
+
+    public void putLongArray(String key, long[] array)
+    {
+        put(key, new LongArrayTag(array));
+    }
+
     public CompoundTag getCompound(String key)
     {
         return getCompoundOrDefault(key, new CompoundTag());
@@ -368,18 +391,31 @@ public class CompoundTag extends Tag<Map<String, Tag<?>>>
         Map<String, Tag<?>> data1 = this.getValue();
         Map<String, Tag<?>> data2 = ((CompoundTag)o).getValue();
 
-        if(data1.size() != data2.size()) return false;
+        if(data1.size() != data2.size()) {
+//            System.out.println("wrong sizes " + data1.size() + " " + data2.size());
+            return false;
+        }
 
         for(String key : data1.keySet()) {
             Tag<?> value1 = this.getTag(key);
             Tag<?> value2 = ((CompoundTag)o).getTag(key);
 
             if (value1 == null || value2 == null) {
-                if (value1 != value2) return false;
+                if (value1 != value2) {
+//                    System.out.println("Nulls don't match: " + key);
+                    return false;
+                }
                 continue;
             }
 
-            if(!value1.getValue().equals(value2.getValue())) {
+            if(!value1.equals(value2)) {
+//                System.out.println("Values don't equal: " + key);
+//                System.out.println();
+//                System.out.println(value1.getClass());
+//                System.out.println(value1.getValue());
+//                System.out.println();
+//                System.out.println(value2.getClass());
+//                System.out.println(value2.getValue());
                 return false;
             }
         }
diff --git a/game/core/src/main/java/com/mojang/nbt/DoubleArrayTag.java b/util/nbt/src/main/java/com/mojang/nbt/tags/DoubleArrayTag.java
similarity index 62%
rename from game/core/src/main/java/com/mojang/nbt/DoubleArrayTag.java
rename to util/nbt/src/main/java/com/mojang/nbt/tags/DoubleArrayTag.java
index e128c9410..afc2b2f3c 100644
--- a/game/core/src/main/java/com/mojang/nbt/DoubleArrayTag.java
+++ b/util/nbt/src/main/java/com/mojang/nbt/tags/DoubleArrayTag.java
@@ -1,15 +1,18 @@
-package com.mojang.nbt;
+package com.mojang.nbt.tags;
+
+import org.jetbrains.annotations.NotNull;
 
 import java.io.*;
 import java.nio.ByteBuffer;
 import java.nio.ByteOrder;
+import java.util.Arrays;
 
-public class DoubleArrayTag extends Tag<double[]>
+public class DoubleArrayTag extends Tag<double @NotNull []>
 {
 
     public DoubleArrayTag()
     {
-        setValue(new double[0]);
+        this(new double[0]);
     }
 
     public DoubleArrayTag(double[] array)
@@ -18,22 +21,22 @@ public class DoubleArrayTag extends Tag<double[]>
     }
 
     @Override
-    void write(DataOutput dos)
+    void write(@NotNull DataOutput dos)
         throws IOException
     {
         dos.writeInt(getValue().length);
-        byte[] bytes = new byte[getValue().length * 8];
+        byte[] bytes = new byte[getValue().length * Double.BYTES];
         ByteBuffer.wrap(bytes).order(ByteOrder.LITTLE_ENDIAN).asDoubleBuffer().put(getValue());
         dos.write(bytes);
     }
 
     @Override
-    void read(DataInput dis)
+    void read(@NotNull DataInput dis)
         throws IOException
     {
         int length = dis.readInt();
         setValue(new double[length]);
-        byte[] bytes = new byte[length * 8];
+        byte[] bytes = new byte[length * Double.BYTES];
         dis.readFully(bytes);
         ByteBuffer.wrap(bytes).order(ByteOrder.LITTLE_ENDIAN).asDoubleBuffer().get(getValue());
     }
@@ -41,7 +44,7 @@ public class DoubleArrayTag extends Tag<double[]>
     @Override
     public byte getId()
     {
-        return 12;
+        return TAG_DOUBLE_ARRAY;
     }
 
     @Override
@@ -63,4 +66,13 @@ public class DoubleArrayTag extends Tag<double[]>
             return sb.toString();
         }
     }
+
+    @Override
+    public boolean equals(Object obj) {
+        if(!(obj instanceof DoubleArrayTag)) return false;
+        DoubleArrayTag otherTag = (DoubleArrayTag) obj;
+        double[] thisData = getValue();
+        double[] otherData = otherTag.getValue();
+        return Arrays.equals(thisData, otherData);
+    }
 }
diff --git a/game/core/src/main/java/com/mojang/nbt/DoubleTag.java b/util/nbt/src/main/java/com/mojang/nbt/tags/DoubleTag.java
similarity index 65%
rename from game/core/src/main/java/com/mojang/nbt/DoubleTag.java
rename to util/nbt/src/main/java/com/mojang/nbt/tags/DoubleTag.java
index f7f97caf0..890c87c3d 100644
--- a/game/core/src/main/java/com/mojang/nbt/DoubleTag.java
+++ b/util/nbt/src/main/java/com/mojang/nbt/tags/DoubleTag.java
@@ -1,12 +1,15 @@
-package com.mojang.nbt;
+package com.mojang.nbt.tags;
+
+import org.jetbrains.annotations.NotNull;
 
 import java.io.*;
 
-public class DoubleTag extends Tag<Double>
+public class DoubleTag extends Tag<@NotNull Double>
 {
 
     public DoubleTag()
     {
+        this(0);
     }
 
     public DoubleTag(double value)
@@ -15,14 +18,14 @@ public class DoubleTag extends Tag<Double>
     }
 
     @Override
-    void write(DataOutput dos)
+    void write(@NotNull DataOutput dos)
         throws IOException
     {
         dos.writeDouble(getValue());
     }
 
     @Override
-    void read(DataInput dis)
+    void read(@NotNull DataInput dis)
         throws IOException
     {
         setValue(dis.readDouble());
@@ -31,7 +34,7 @@ public class DoubleTag extends Tag<Double>
     @Override
     public byte getId()
     {
-        return 6;
+        return TAG_DOUBLE;
     }
 
     @Override
diff --git a/game/core/src/main/java/com/mojang/nbt/EndTag.java b/util/nbt/src/main/java/com/mojang/nbt/tags/EndTag.java
similarity index 67%
rename from game/core/src/main/java/com/mojang/nbt/EndTag.java
rename to util/nbt/src/main/java/com/mojang/nbt/tags/EndTag.java
index bd7d3b694..c83e0a9ee 100644
--- a/game/core/src/main/java/com/mojang/nbt/EndTag.java
+++ b/util/nbt/src/main/java/com/mojang/nbt/tags/EndTag.java
@@ -1,4 +1,6 @@
-package com.mojang.nbt;
+package com.mojang.nbt.tags;
+
+import org.jetbrains.annotations.NotNull;
 
 import java.io.*;
 
@@ -10,13 +12,13 @@ public class EndTag extends Tag<Void>
     }
 
     @Override
-    void read(DataInput dis)
+    void read(@NotNull DataInput dis)
         throws IOException
     {
     }
 
     @Override
-    void write(DataOutput dos)
+    void write(@NotNull DataOutput dos)
         throws IOException
     {
     }
@@ -24,7 +26,7 @@ public class EndTag extends Tag<Void>
     @Override
     public byte getId()
     {
-        return 0;
+        return TAG_END;
     }
 
     @Override
diff --git a/game/core/src/main/java/com/mojang/nbt/FloatTag.java b/util/nbt/src/main/java/com/mojang/nbt/tags/FloatTag.java
similarity index 65%
rename from game/core/src/main/java/com/mojang/nbt/FloatTag.java
rename to util/nbt/src/main/java/com/mojang/nbt/tags/FloatTag.java
index 2ebef7a19..8266f004a 100644
--- a/game/core/src/main/java/com/mojang/nbt/FloatTag.java
+++ b/util/nbt/src/main/java/com/mojang/nbt/tags/FloatTag.java
@@ -1,12 +1,15 @@
-package com.mojang.nbt;
+package com.mojang.nbt.tags;
+
+import org.jetbrains.annotations.NotNull;
 
 import java.io.*;
 
-public class FloatTag extends Tag<Float>
+public class FloatTag extends Tag<@NotNull Float>
 {
 
     public FloatTag()
     {
+        this(0);
     }
 
     public FloatTag(float value)
@@ -15,14 +18,14 @@ public class FloatTag extends Tag<Float>
     }
 
     @Override
-    void write(DataOutput dos)
+    void write(@NotNull DataOutput dos)
         throws IOException
     {
         dos.writeFloat(getValue());
     }
 
     @Override
-    void read(DataInput dis)
+    void read(@NotNull DataInput dis)
         throws IOException
     {
         setValue(dis.readFloat());
@@ -31,7 +34,7 @@ public class FloatTag extends Tag<Float>
     @Override
     public byte getId()
     {
-        return 5;
+        return TAG_FLOAT;
     }
 
     @Override
diff --git a/game/core/src/main/java/com/mojang/nbt/IntTag.java b/util/nbt/src/main/java/com/mojang/nbt/tags/IntTag.java
similarity index 65%
rename from game/core/src/main/java/com/mojang/nbt/IntTag.java
rename to util/nbt/src/main/java/com/mojang/nbt/tags/IntTag.java
index a640383b8..03c94a1b6 100644
--- a/game/core/src/main/java/com/mojang/nbt/IntTag.java
+++ b/util/nbt/src/main/java/com/mojang/nbt/tags/IntTag.java
@@ -1,12 +1,15 @@
-package com.mojang.nbt;
+package com.mojang.nbt.tags;
+
+import org.jetbrains.annotations.NotNull;
 
 import java.io.*;
 
-public class IntTag extends Tag<Integer>
+public class IntTag extends Tag<@NotNull Integer>
 {
 
     public IntTag()
     {
+        this(0);
     }
 
     public IntTag(int value)
@@ -15,14 +18,14 @@ public class IntTag extends Tag<Integer>
     }
 
     @Override
-    void write(DataOutput dos)
+    void write(@NotNull DataOutput dos)
         throws IOException
     {
         dos.writeInt(getValue());
     }
 
     @Override
-    void read(DataInput dis)
+    void read(@NotNull DataInput dis)
         throws IOException
     {
         setValue(dis.readInt());
@@ -31,7 +34,7 @@ public class IntTag extends Tag<Integer>
     @Override
     public byte getId()
     {
-        return 3;
+        return TAG_INT;
     }
 
     @Override
diff --git a/game/core/src/main/java/com/mojang/nbt/ListTag.java b/util/nbt/src/main/java/com/mojang/nbt/tags/ListTag.java
similarity index 75%
rename from game/core/src/main/java/com/mojang/nbt/ListTag.java
rename to util/nbt/src/main/java/com/mojang/nbt/tags/ListTag.java
index 9f3b10cf5..b769ac4aa 100644
--- a/game/core/src/main/java/com/mojang/nbt/ListTag.java
+++ b/util/nbt/src/main/java/com/mojang/nbt/tags/ListTag.java
@@ -1,4 +1,7 @@
-package com.mojang.nbt;
+package com.mojang.nbt.tags;
+
+import com.mojang.nbt.UnknownTagException;
+import org.jetbrains.annotations.NotNull;
 
 import java.io.*;
 import java.util.ArrayList;
@@ -6,13 +9,14 @@ import java.util.Iterator;
 import java.util.List;
 
 public class ListTag
-    extends Tag<List<Tag<?>>>
+    extends Tag<@NotNull List<Tag<?>>>
     implements Iterable<Tag<?>>
 {
+    private byte tagType;
 
     public ListTag()
     {
-        setValue(new ArrayList<>());
+        this(new ArrayList<>());
     }
 
     public ListTag(List<Tag<?>> array)
@@ -21,10 +25,10 @@ public class ListTag
     }
 
     @Override
-    void write(DataOutput dos)
+    void write(@NotNull DataOutput dos)
         throws IOException
     {
-        if(getValue().size() > 0)
+        if(!getValue().isEmpty())
         {
             tagType = getValue().get(0).getId();
         } else
@@ -41,7 +45,7 @@ public class ListTag
     }
 
     @Override
-    void read(DataInput dis)
+    void read(@NotNull DataInput dis)
         throws IOException
     {
         tagType = dis.readByte();
@@ -51,20 +55,20 @@ public class ListTag
 
         for(int i = 0; i < length; i++)
         {
-            Tag<?> tag = Tag.newTag(tagType);
-            if (tag != null)
-            {
+            try {
+                Tag<?> tag = newTag(tagType);
                 tag.read(dis);
                 getValue().add(tag);
+            } catch (IllegalArgumentException illegalArgumentException) {
+                throw new UnknownTagException("Unknown tag type '" + tagType + "'!");
             }
         }
-
     }
 
     @Override
     public byte getId()
     {
-        return 9;
+        return TAG_LIST;
     }
 
     @Override
@@ -103,10 +107,8 @@ public class ListTag
         return getValue().size();
     }
 
-    private byte tagType;
-
     @Override
-    public Iterator<Tag<?>> iterator()
+    public @NotNull Iterator<Tag<?>> iterator()
     {
         return getValue().iterator();
     }
